//The ALU of the MIPS
//Kamyar Rafati & Naeem Esfahani

module ALU_mips (A, B, Opcode, y, zero, carry);
	input[15:0]		A, B;
	input[1:0]		Opcode;
	output[15:0]	y;
	output			zero;
	output			carry;
	reg[15:0]		y;
	reg				zero;
	reg				carry;

	always @(A or B or Opcode)
	begin
		case(Opcode)
			0: {carry,y} = A+B;
			1: {carry,y} = A-B;
			2: y = A&B;
			3: y = A|B;
		endcase
	end
	
	always @(y or Opcode)
	begin
		if (Opcode == 5)
		begin
			if (y==0)
				zero = 0;
			else
				zero = 1;
		end
		else
		begin
			if (y==0)
				zero = 1;
			else
				zero = 0;
		end
	end
endmodule
