//Control Unit
//Kamyar Rafati & Naeem Esfahani

module Control (IsFull,IsEmpty,i,Op,PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,PCWriteCond,AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp,reset,Enq,Deq,clk);
	input[15:0]	Op;
	input		clk, reset,i,IsFull,IsEmpty;

  output PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,Enq,Deq,PCWriteCond;
	output [1:0]AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp;

  reg PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,Enq,Deq,PCWriteCond;
	reg [1:0]AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp;
	integer current,next;

	initial
	begin		
		iset=0;
		eset=0;
		ireset=1;
		ereset=1;
		#1;
		ireset=0;
		ereset=0;
	end

	always @(posedge clk or reset)
	begin	
			if ( reset==1) next=0;
			current =next;
	end
	always @(current or posedge clk)
	begin
		{PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,Enq,Deq,PCWriteCond}=18'b0;
		{AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp}=14'b0;
		case (current)
			0://initial 
			begin
				AluA=0;
				AluB=1;
				PCSrc=0;
				RReg=0;
				PCWrite=1;
				IorD=0;
				AluOp=0;
				IRWrite=1;
			end
			1://Class B
			begin
				RReg=2;
			end		
			2://Class B
			begin
				AluA=1;
				AluB=0;
				AluOp=Op[13:12]-2;
				zwe=1;
				nwe=1;
				RReg=2;
				cwe=1;
			end
			3://Class B
			begin
				RegWrite=1;
				RegDst=2;
				RegData=2;
			end
			4://Class C
			begin
				AluA=0;
				AluB=3;
				AluOp=0;
				PCWriteCond=1;
				PCSrc=0;
			end
			5://Class D  &  I = 0
			begin
				eset=1;
			end
			6://Class D  &  I = 1
			begin
				RReg=1;
				PCSrc=1;
				PCCond=1;
			end
			7://Class D & I = 1 completion
			begin
				PCSrc=1;
				ireset=1;
			end
			8://Class E
			begin
				RegWrite=1;
				RegDst=2;
				RegData=3;
			end
			9://Load
			begin
				IorD=1;
				IRWrite=0;
			end
			10://Load
			begin
				RegWrite=1;
				RegDst=0;
				RegData=0;
			end
			11://Store
			begin
				IorD=1;
				WriteData=0;
				MemWrite=1;
			end
			12://Jump
			begin
				PCSrc=2;
				PCWrite=1;
			end
			13://Int  & I = 1
			begin
				eset=1;
			end
			14://Int & I = 0
			begin
				RegData=1;
				RegWrite=1;
				RegDst=1;
			end
			15://Int & I = 0
			begin
				PCWrite=1;
				PCSrc=2;
				iset=1;
			end
			16://Enqueue
			begin
				IorD=1;
				MemWrite=0;
				IRWrite=0;
				Enq=1;
			end
			17://Enqueue
			begin

			end
			18://Dequeue
			begin
				Deq=1;
			end
			19://Dequeue
			begin
				IorD=1;
				MemWrite=1;
				WriteData=1;
			end
		endcase
	end
	always @(current or Op or i or posedge clk)
	begin
		case (current)
			0://initial 
			begin
				if((Op[15:12] <= 9)&&(Op[15:12] >= 6)) 
					next=1;

				else if(Op[15:12] == 10)
					next=4;

				else if(Op[15:12] == 11)
					begin
						if (i==0)
							next=5;
						else
							next=6;
					end					

				else if(Op[15:12] == 12)
					next=8;

				else if(Op[15:12] == 5)
					begin
						if(i==0) next=14;
						else next=13;
					end

				else if(Op[15:12] == 4)
					next=12;

				else if(Op[15:12] == 3)
					next=11;

				else if(Op[15:12] == 2)
					next=9;

				else if(Op[15:12] == 1)
					next=18;

				else if(Op[15:12] == 0)
					next=16;
			end
			1://Class B
				next=2;
			2://Class B
				next=3;
			3://Class B
				next=0;
			4://Class C
				next=0;
			5://Class D  &  I = 0
				next=0;
			6://Class D  &  I = 1
				next=7;
			7://Class D & I = 1 completion
				next=0;
			8://Class E
				next=0;
			9://Load
				next=10;
			10://Load
				next=0;
			11://Store
				next=0;
			12://Jump
				next=0;
			13://Int  & I = 1
				next=0;
			14://Int & I = 0
				next=15;
			15://Int & I = 0
				next=0;
			16://Enqueue
				next=17;
			17://Enqueue
				next=0;
			18://Dequeue
				next=19;
			19://Dequeue
				next=0;
		endcase
	end
	
endmodule
