module Q(Out,Size,IsFull,IsEmpty,Error,InData,Enq,Deq,clk);
	input [15:0] InData;
	input Enq,Deq,clk;
	
	output IsFull,IsEmpty,Error;
	output [15:0] Out,Size;
	
	reg IsFull,IsEmpty,Error;
	reg [15:0] Size;
	reg [5:0] Head,Tail,Count;
	reg s,re,we;
	
	wire [5:0] Addr;

	MUX2x1_6bit mux(s, Head, Tail, Addr);
	QueueMemory mem(Addr,InData,Out,we,re,clk);
	
	initial
	begin
		Error=0;
		Head=0;
		Tail=0;
		Count=0;
	end

	always @(posedge clk)
	begin
		we=0;
		re=0;
		if(Enq == 1)
			begin
				if(IsFull == 1)
					Error = 1;
				else
					begin
						s = 0;
						we = 1;
						Head = Head + 1;
						Count = Count + 1;
					end
			end
		else if(Deq == 1)
			begin
				if(IsEmpty == 1)
					Error = 1;
				else
					begin
						s = 1;
						re = 1;
						Tail = Tail + 1;
						Count = Count - 1;
					end
			end
	end

	always @(Count)
	begin
		IsEmpty = 0;
		IsFull = 0;
		Size = {10'b0000000000,Count};
		if(Count == 0)
			IsEmpty = 1;
		if(Count == 63)
			IsFull = 1;
	end

endmodule